# impl_base.hpp File Reference

`#include <cstdlib>`
`#include <cstddef>`
`#include <saga/saga/export_definitions.hpp>`
`#include <sstream>`

Go to the source code of this file.

## Defines
#define | SAGA_CPIVERSION_1_0 0x0100
#define | SAGA_CPIVERSION_MINORMASK 0x000F
#define | SAGA_CPIVERSION_LATEST SAGA_CPIVERSION_1_0
#define | SAGA_VERBOSE_LOG_FACILITY __FILE__
#define | SAGA_VERBOSE(x)
#define | SAGA_LOG(level, msg)
#define | SAGA_LOG_ALWAYS(msg) SAGA_LOG (SAGA_VERBOSE_LEVEL_ALWAYS,msg) \
#define | SAGA_LOG_CRITICAL(msg) SAGA_LOG (SAGA_VERBOSE_LEVEL_CRITICAL,msg) \
#define | SAGA_LOG_ERROR(msg) SAGA_LOG (SAGA_VERBOSE_LEVEL_ERROR,msg) \
#define | SAGA_LOG_WARN(msg) SAGA_LOG (SAGA_VERBOSE_LEVEL_WARNING,msg) \
#define | SAGA_LOG_INFO(msg) SAGA_LOG (SAGA_VERBOSE_LEVEL_INFO,msg) \
#define | SAGA_LOG_DEBUG(msg) SAGA_LOG (SAGA_VERBOSE_LEVEL_DEBUG,msg) \
#define | SAGA_LOG_BLURB(msg) SAGA_LOG (SAGA_VERBOSE_LEVEL_BLURB,msg) \
#define | SAGA_VERBOSE_LEVEL_ALWAYS 0
#define | SAGA_VERBOSE_LEVEL_CRITICAL 1
#define | SAGA_VERBOSE_LEVEL_ERROR 2
#define | SAGA_VERBOSE_LEVEL_WARNING 3
#define | SAGA_VERBOSE_LEVEL_INFO 4
#define | SAGA_VERBOSE_LEVEL_DEBUG 5
#define | SAGA_VERBOSE_LEVEL_BLURB 6
#define | SAGA_OSSTREAM_GETSTRING(ss) ss.str()
#define | SAGA_OSSTREAM std::ostringstream
#define | SAGA_ISSTREAM std::istringstream
## Variables
char const *const | SAGA_VERBOSE_LEVEL_ALWAYS_MSG = "LOG"
char const *const | SAGA_VERBOSE_LEVEL_CRITICAL_MSG = "CRITICAL"
char const *const | SAGA_VERBOSE_LEVEL_ERROR_MSG = "ERROR"
char const *const | SAGA_VERBOSE_LEVEL_WARNING_MSG = "WARNING"
char const *const | SAGA_VERBOSE_LEVEL_INFO_MSG = "INFO"
char const *const | SAGA_VERBOSE_LEVEL_DEBUG_MSG = "DEBUG"
char const *const | SAGA_VERBOSE_LEVEL_BLURB_MSG = "BLURB"

## Define Documentation

#define SAGA_CPIVERSION_1_0 0x0100

#define SAGA_CPIVERSION_MINORMASK 0x000F

#define SAGA_CPIVERSION_LATEST SAGA_CPIVERSION_1_0

#define SAGA_VERBOSE_LOG_FACILITY __FILE__

#define SAGA_VERBOSE | ( | x |  | ) |

Value:

    if ( NULL !=       saga::safe_getenv ("SAGA_VERBOSE")  &&             \
                    x <= atoi (saga::safe_getenv ("SAGA_VERBOSE")) )              \

#define SAGA_LOG | ( | level,
|  | msg |  | ) |

Value:

    SAGA_VERBOSE (level)                                                   \
           {                                                                      \
              fprintf (stderr, "%-10s : %-25s : %s\n",                            \
                       level ## _MSG, SAGA_VERBOSE_LOG_FACILITY, msg);            \
           }                                                                      \

#define SAGA_LOG_ALWAYS | ( | msg |  | ) | SAGA_LOG (SAGA_VERBOSE_LEVEL_ALWAYS,msg) \

#define SAGA_LOG_CRITICAL | ( | msg |  | ) | SAGA_LOG (SAGA_VERBOSE_LEVEL_CRITICAL,msg) \

#define SAGA_LOG_ERROR | ( | msg |  | ) | SAGA_LOG (SAGA_VERBOSE_LEVEL_ERROR,msg) \

#define SAGA_LOG_WARN | ( | msg |  | ) | SAGA_LOG (SAGA_VERBOSE_LEVEL_WARNING,msg) \

#define SAGA_LOG_INFO | ( | msg |  | ) | SAGA_LOG (SAGA_VERBOSE_LEVEL_INFO,msg) \

#define SAGA_LOG_DEBUG | ( | msg |  | ) | SAGA_LOG (SAGA_VERBOSE_LEVEL_DEBUG,msg) \

#define SAGA_LOG_BLURB | ( | msg |  | ) | SAGA_LOG (SAGA_VERBOSE_LEVEL_BLURB,msg) \

#define SAGA_VERBOSE_LEVEL_ALWAYS 0

#define SAGA_VERBOSE_LEVEL_CRITICAL 1

#define SAGA_VERBOSE_LEVEL_ERROR 2

#define SAGA_VERBOSE_LEVEL_WARNING 3

#define SAGA_VERBOSE_LEVEL_INFO 4

#define SAGA_VERBOSE_LEVEL_DEBUG 5

#define SAGA_VERBOSE_LEVEL_BLURB 6

#define SAGA_OSSTREAM_GETSTRING | ( | ss |  | ) | ss.str()

#define SAGA_OSSTREAM std::ostringstream

#define SAGA_ISSTREAM std::istringstream

## Variable Documentation

char const* const SAGA_VERBOSE_LEVEL_ALWAYS_MSG = "LOG"

char const* const SAGA_VERBOSE_LEVEL_CRITICAL_MSG = "CRITICAL"

char const* const SAGA_VERBOSE_LEVEL_ERROR_MSG = "ERROR"

char const* const SAGA_VERBOSE_LEVEL_WARNING_MSG = "WARNING"

char const* const SAGA_VERBOSE_LEVEL_INFO_MSG = "INFO"

char const* const SAGA_VERBOSE_LEVEL_DEBUG_MSG = "DEBUG"

char const* const SAGA_VERBOSE_LEVEL_BLURB_MSG = "BLURB"